<?php
/***************************************************************************
 *   Copyright (C) 2005-2006 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once(BASEDIR."side_left.php");
if(file_exists(INFUSIONS."aw_archive/locale/".$settings['locale'].".php")) {
        include INFUSIONS."aw_archive/locale/".$settings['locale'].".php";
} else {
        include INFUSIONS."aw_archive/locale/German.php";
}

/* global const/vars */
define("AW_DIR",	"articles/");
define("AW_CONTENT",	AW_DIR."content.html");
define("AW_EXT",	".html");

$serverpath = getcwd() . "/";


function generate_index($dir, &$retval, &$my_subdirs) {
	global $serverpath, $locale;

	if(!is_dir($dir)) {
		return false;
	}
	$dh = opendir($dir);
	if(!$dh) {
		return false;
	}

	$count = 0;
	chdir($dir);

	// traverse one level subdirs
	while(false !== ($subdir = readdir($dh))) {
		if($subdir=="." || $subdir==".." || !is_dir($subdir)) {
			continue;
		}

		$count++;

		$caption = phpentities(ereg_replace("_", " ", $subdir));
		$my_subdirs .= "<img src='".THEME."images/bullet.gif'>"
			." <a href='".FUSION_SELF."#$count'>$caption</a><br/>";
		$retval .= "<a name='$count'></a><p><table width='100%'"
			." cellspacing='1' class='tbl-border'>\n"
			."<tr class='tbl2'><td><b>$caption</b></td>"
			."<td align='right'><a href='".FUSION_SELF."'>"
				.$locale['top']."</a></td>";

		// for each AW_EXT in our subdir.
		chdir($subdir);
		foreach(glob("*".AW_EXT) as $file) {
			// read title
			$id = fopen("$serverpath/$dir/$subdir/$file", "r");
			$file = basename($file, AW_EXT);
			if($id) {
				$title = phpentities(strip_tags(fgets($id)));
				$comment = phpentities(strip_tags(fgets($id)));
				fclose($id);
			} else {
				$title = $file;
			}

			$retval .= "\n<tr>"
				."<td class='tbl1' width='50%' valign='top'>"
				."<a href='".FUSION_SELF."?article_id="
				."$subdir/$file'>$title</a></td>"
				."<td class='tbl1' valign='top'>$comment</td>";
		}

		chdir("..");
		$retval .= "</table>\n";
	}

	chdir("..");
	closedir($dh);
	return true;
}

if(iSUPERADMIN) {
	// delete file
	if(isset($_GET['delete_index'])) {
		$do_create = false;
		if(file_exists(AW_CONTENT) && unlink(AW_CONTENT)) {
			echo "<p>".$locale['deleted'];
		} else {
			echo "<p>".$locale['failed'];
		}
		redirect(FUSION_SELF);
	}

	// create index
	if(isset($_GET['create_index'])) {
		$my_index = "<p>";
		$my_subdirs = "<p>";
		if(!generate_index(AW_DIR, $my_index, $my_subdirs)) {
			echo "<p>".$locale['failed'];
		}

		$id = fopen(AW_CONTENT, "w");
		if($id) {
			if(fwrite($id, $my_subdirs.$my_index) === false) {
				echo "<p>".$locale['err_write'];
			}
			fclose($id);
			chmod(AW_CONTENT, 0666);
		}
		redirect(FUSION_SELF);
	}
}


/* GUI */
opentable($locale['aw_title']);


// admin menu
if(iSUPERADMIN) {
	echo "<table width='100%' class='tbl-border' cellspacing='1'>
<tr class='forum-caption'>
	<td align='right'>".$locale['admin'].":
	[<a href='".FUSION_SELF ."?create_index=Y'>".$locale['create']."</a>]
	[<a href='".FUSION_SELF ."?delete_index=Y'>".$locale['delete']."</a>]
	</td>
</table>\n";
}


// show article/index
if(isset($_GET['article_id'])) {
	if(preg_match("/^[a-zA-Z]/", $_GET['article_id'])) {
		$article_id = $_GET['article_id'];
	} else {
		redirect(FUSION_SELF);
	}
} else {
	unset($article_id);
}

if(isset($article_id)) {
	echo "<p><a href='" . FUSION_SELF . "'>".$locale['back']."</a>\n";
	include(AW_DIR . $article_id.AW_EXT);
	echo "<p><a href='" . FUSION_SELF . "'>".$locale['back']."</a>\n";
} else { 
	if(file_exists(AW_CONTENT)) {
		include(AW_CONTENT);
	} else {
		echo "<p>".$locale['no_index'];
	}
}


closetable();


require_once(BASEDIR."side_right.php");
require_once(BASEDIR."footer.php");
?>

